// MRUManager.h
// (c) 2003-2004 exeal

#ifndef _MRU_MANAGER_H_
#define _MRU_MANAGER_H_

#include <list>
#include "..\Manah\Menu.h"
#include "Ascension\Encodings\Encoder.h"


namespace Alpha {
	///	ŋߎgt@C̏
	struct TMRU {
		std::wstring					strFileName;	///< t@C
		Ascension::Encodings::CodePage	nCodePage;		///< R[hy[W
	};

	///	ŋߎgt@C̊Ǘ
	class CMRUManager {
		// RXgN^
	public:
		CMRUManager(unsigned short cLimit, int nStartID, bool bOwnerDrawMenu = false);
		virtual ~CMRUManager();

		// \bh
	public:
		void								Add(const std::wstring& strFilePath, Ascension::Encodings::CodePage nCodePage);
		void								Clear();
		unsigned short						GetCount() const;
		const TMRU&							GetFileInfoAt(unsigned short i) const throw(std::out_of_range);
		Manah::Windows::Controls::CMenu*	GetPopupMenu() const;
		void								Remove(unsigned short i) throw(std::out_of_range);
		void								SetLimit(unsigned short cLimit);
	protected:
		void								_ReconstructMenu();

		// f[^o
	private:
		int									m_nStartID;		// j[ ID ̐擪̒l
		std::list<TMRU>						m_fileNames;	// tpX̃Xg
		Manah::Windows::Controls::CMenu*	m_pPopupMenu;	// |bvAbvj[
		unsigned short						m_cLimit;		// ڐ̏ (4ȏ16ȉ)
		bool								m_bOwnerDraw;	// j[I[i[h[ɂ邩
	};
}

#endif /* _MRU_MANAGER_H_ */

/* [EOF] */