// WebBrowserContainer.h
// (c) 2003-2004 exeal

#ifndef _WEB_BROWSER_CONTAINER_H_
#define _WEB_BROWSER_CONTAINER_H_

#include <exdisp.h>
#include "BufferList.h"
#include "../Armaiti/UnknownImpl.h"
//#include "../Manah/HtmlCtrl.h"
#if 0

namespace Alpha {
	class CWebBrowserContainer :
			virtual public IDocumentContainer,
			virtual public IOleContainer,
			virtual public IOleInPlaceFrame,
			virtual public IOleInPlaceSite,
			virtual public IOleClientSite {
		// RXgN^
	public:
		CWebBrowserContainer();
		virtual ~CWebBrowserContainer();

		// \bh
	public:
		bool	Create(HWND hwndParent, DWORD dwStyle, DWORD dwExStyle);
		void	GoBack();
		void	GoForward();
		void	GoHome();
		void	Navigate(const wchar_t* pwszUri);

		// IUnknown C^[tFCX
		IMPLEMENT_UNKNOWN_NO_REF_COUNT()
		BEGIN_INTERFACE_TABLE()
			IMPLEMENTS_LEFTMOST_INTERFACE(IOleContainer)
			IMPLEMENTS_INTERFACE(IParseDisplayName)
//			IMPLEMENTS_INTERFACE(IOleWindow)
			IMPLEMENTS_INTERFACE(IOleInPlaceUIWindow)
			IMPLEMENTS_INTERFACE(IOleInPlaceFrame)
			IMPLEMENTS_INTERFACE(IOleInPlaceSite)
			IMPLEMENTS_INTERFACE(IOleClientSite)
		END_INTERFACE_TABLE()

		// IDocumentContainer C^[tFCX
		void					DeleteInstance();
		std::wstring			GetDescription() const;
		std::wstring			GetFilePath() const;
		CAlphaEditController*	GetTextEditor() const;
		std::wstring			GetTitle() const;
		HWND					GetWindow() const;
		void					RefreshWindow();
		void					OnActivate(bool bActive);

		// IParseDisplayName C^[tFCX
		STDMETHODIMP	ParseDisplayName(IBindCtx* pbc, LPOLESTR pszDisplayName, ULONG* pchEaten, IMoniker** ppmkOut);

		// IOleContainer C^[tFCX
		STDMETHODIMP	EnumObjects(DWORD grfFlags, IEnumUnknown** ppenum);
		STDMETHODIMP	LockContainer(BOOL fLock);

		// IOleWindow C^[tFCX
		STDMETHODIMP	GetWindow(HWND* phwnd);
		STDMETHODIMP	ContextSensitiveHelp(BOOL fEnterMode);

		// IOleInPlaceUIWindow C^[tFCX
		STDMETHODIMP	GetBorder(LPRECT lprectBorder);
		STDMETHODIMP	RequestBorderSpace(LPCBORDERWIDTHS pborderwidths);
		STDMETHODIMP	SetBorderSpace(LPCBORDERWIDTHS pborderwidths);
		STDMETHODIMP	SetActiveObject(IOleInPlaceActiveObject* pActiveObject, LPCOLESTR pszObjName);

		// IOleInPlaceFrame C^[tFCX
		STDMETHODIMP	InsertMenus(HMENU hmenuShared, LPOLEMENUGROUPWIDTHS lpMenuWidths);
		STDMETHODIMP	SetMenu(HMENU hmenuShared, HOLEMENU holemenu, HWND hwndActiveObject);
		STDMETHODIMP	RemoveMenus(HMENU hmenuShared);
		STDMETHODIMP	SetStatusText(LPCOLESTR pszStatusText);
		STDMETHODIMP	EnableModeless(BOOL fEnable);
		STDMETHODIMP	TranslateAccelerator(LPMSG lpmsg, WORD wID);

		// IOleInPlaceSite C^[tFCX
		STDMETHODIMP	CanInPlaceActivate();
		STDMETHODIMP	OnInPlaceActivate();
		STDMETHODIMP	OnUIActivate();
		STDMETHODIMP	GetWindowContext(IOleInPlaceFrame** ppFrame, IOleInPlaceUIWindow** ppDoc,
							LPRECT lprcPosRect, LPRECT lprcClipRect, LPOLEINPLACEFRAMEINFO lpFrameInfo);
		STDMETHODIMP	Scroll(SIZE scrollExtant);
		STDMETHODIMP	OnUIDeactivate(BOOL fUndoable);
		STDMETHODIMP	OnInPlaceDeactivate();
		STDMETHODIMP	DiscardUndoState();
		STDMETHODIMP	DeactivateAndUndo();
		STDMETHODIMP	OnPosRectChange(LPCRECT lprcPosRect);

		// IOleClientSite C^[tFCX
		STDMETHODIMP	SaveObject();
		STDMETHODIMP	GetMoniker(DWORD dwAssign, DWORD dwWhichMoniker, IMoniker** ppmk);
		STDMETHODIMP	GetContainer(IOleContainer** ppContainer);
		STDMETHODIMP	ShowObject();
		STDMETHODIMP	OnShowWindow(BOOL fShow);
		STDMETHODIMP	RequestNewObjectLayout();

		// f[^o
	private:
		IWebBrowser2*	m_pBrowser;
	};
} // namspace Alpha

#endif
#endif /* _WEB_BROWSER_CONTAINER_H_ */

/* [EOF] */